## yade 2022.01a

=== CMakeLists.txt ===
# The YADE has the following parameters to configure:
#  CMAKE_INSTALL_PREFIX: path, where Yade will be installed (/usr/local by default)
#  LIBRARY_OUTPUT_PATH: path to install libraries (lib by default)
#  DEBUG: compile in debug-mode (OFF by default)
#  MAX_LOG_LEVEL: set maximum level for LOG_* macros compiled with ENABLE_LOGGER. For production build use MAX_LOG_LEVEL<=5, to avoid filter integer comparison on each call to LOG_TRACE(…)
#  CMAKE_VERBOSE_MAKEFILE: output additional information during compiling (OFF by default)
#  CMAKE_TIMING_VERBOSE: custom output for timing per target  (OFF by default)
#  SUFFIX: suffix, added after binary-names (version number by default)
#  NOSUFFIX: do not add a suffix after binary-name (OFF by default)
#  YADE_VERSION: explicitely set version number (is defined from git-directory by default)
#
#  DISABLE_ALL: disable all options (OFF by default)
#
#  ENABLE_ASAN                : AddressSanitizer build, please see documentation (OFF by default)
#  ENABLE_CGAL                : enable CGAL option (ON by default)
#  ENABLE_COMPLEX_MP          : Requires boost >= 1.71: use boost::multiprecision for ComplexHP: (1) complex128 (2) mpc_complex (3) complex_adaptor (ON by default); Otherwise uses std::complex<…>.
#  ENABLE_DEFORM              : enable constant volume deformation engine (OFF by default)
#  ENABLE_FAST_NATIVE         : use max optimization, code runs only on the same processor type; speedup about 2%, and above 5% with clang compiler, which requires ENABLE_USEFUL_ERRORS=OFF (OFF by default)
#  ENABLE_FEMLIKE             : enable meshed solids (FEM-like)
#  ENABLE_GL2PS               : enable GL2PS-option (ON by default)
#  ENABLE_GTS                 : enable GTS-option (ON by default)
#  ENABLE_GUI                 : enable GUI option (ON by default)
#  ENABLE_LBMFLOW             : enable LBMFLOW-option, LBM_ENGINE (ON by default)
#  ENABLE_LINSOLV             : enable LINSOLV-option (ON by default)
#  ENABLE_LIQMIGRATION        : enable LIQMIGRATION-option, see [Mani2013] for details (OFF by default)
#  ENABLE_LOGGER              : use boost::log library for logging (ON by default)
#  ENABLE_LS_DEM              : enable level-set shape description (ON by default)
#  ENABLE_MASK_ARBITRARY      : enable MASK_ARBITRARY option (OFF by default)
#  ENABLE_MPFR                : use https://www.mpfr.org/ library, can be used for higher precision calculations or for CGAL exact predicates (OFF by default)
#  ENABLE_MPI                 : Enable MPI communications in Yade. Used for Yade-OpenFOAM coupling.
#  ENABLE_OAR                 : generate a script for oar-based task scheduler (OFF by default)
#  ENABLE_OPENMP              : enable OpenMP-parallelizing option (ON by default)
#  ENABLE_PARTIALSAT          : enable the partially saturated clay engine, under construction (OFF by default)
#  ENABLE_PFVFLOW             : enable PFVFLOW-option, FlowEngine (ON by default)
#  ENABLE_POTENTIAL_BLOCKS    : enable potential blocks option (ON by default)
#  ENABLE_POTENTIAL_PARTICLES : enable potential particles option (ON by default)
#  ENABLE_PROFILING           : enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)
#  ENABLE_REAL_HP             : allow using twice, quadruple or higher precisions of Real
#  ENABLE_SPH                 : enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default)
#  ENABLE_THERMAL             : enable thermal engine (ON by default, experimental)"
#  ENABLE_TWOPHASEFLOW        : enable TWOPHASEFLOW-option, TwoPhaseFlowEngine (ON by default)
#  ENABLE_USEFUL_ERRORS       : enable useful compiler errors which help a lot in error-free development.
#  ENABLE_VTK                 : enable VTK-export option (ON by default)
#
#  REAL_PRECISION_BITS , REAL_DECIMAL_PLACES: specify either of them to use a custom calculation precision. By default double (64 bits, 15 decimal places) precision is used.
#  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
#  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
#  USE_QT5: use QT5 for GUI (ON by default)
#  CHOLMOD_GPU link Yade to custom SuiteSparse installation and activate GPU accelerated PFV (OFF by default)
#  SUITESPARSEPATH: define this variable with the path to a custom suitesparse install
#  PYTHON_VERSION: force python version to the given one, set -1 to automatically use the last version on the system. (-1 by default)

project(Yade C CXX)
cmake_minimum_required(VERSION 3.5.0)
IF(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0.0)
  set (CMAKE_CXX_STANDARD 14)
ELSE()
  set (CMAKE_CXX_STANDARD 17)
ENDIF()
set (CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE)
#   set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)  #<==== if so, usual make output is replaced by next line, else timing log is one more line
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cMake/custom_output.sh")
endif()


# https://misc.flogisoft.com/bash/tip_colors_and_formatting
# https://stackoverflow.com/questions/18968979/how-to-get-colorized-output-with-cmake , use ${Esc} for printing colors
string(ASCII 27 Esc)
# To have a cmake option with multiple values I used https://cmake.org/pipermail/cmake/2016-October/064342.html
# set maximum level for LOG_* macros compiled with ENABLE_LOGGER. For production build use MAX_LOG_LEVEL below 5, to avoid filter integer comparison on each call to LOG_TRACE(…)
set(MAX_LOG_LEVEL "5" CACHE STRING "default MAX_LOG_LEVEL")
set_property(CACHE MAX_LOG_LEVEL PROPERTY STRINGS "0" "1" "2" "3" "4" "5" "6")  # define list of values GUI will offer for the variable


#===========================================================


OPTION(DISABLE_ALL "Disable all features (OFF by default)" OFF)

SET(DEFAULT_ON ON CACHE INTERNAL "Default ON value for enabled by default options")
SET(DEFAULT_OFF OFF CACHE INTERNAL "Default OFF value for disabled by default options")
SET(LINKLIBS "")
SET(CONFIGURED_FEATS "")
SET(DISABLED_FEATS "")

IF (DISABLE_ALL)
  SET(DEFAULT_ON OFF)
ENDIF (DISABLE_ALL)

OPTION(ENABLE_ASAN "Enable AddressSanitizer build, please see documentation" ${DEFAULT_OFF})
OPTION(ENABLE_CGAL "Enable CGAL" ${DEFAULT_ON})
OPTION(ENABLE_COMPLEX_MP "Use boost::multiprecision for ComplexHP: (1) complex128 (2) mpc_complex MPFR (3) complex_adaptor<cpp_bin_float>, requires boost >= 1.71; Otherwise use std::complex<…>." ${DEFAULT_ON})
OPTION(ENABLE_DEFORM "Enable Deformation Engine" ${DEFAULT_OFF})
OPTION(ENABLE_FEMLIKE "Enable deformable solids" ${DEFAULT_ON})
OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT_ON})
OPTION(ENABLE_GTS "Enable GTS" ${DEFAULT_ON})
OPTION(ENABLE_GUI "Enable GUI" ${DEFAULT_ON})
OPTION(ENABLE_LBMFLOW "Enable LBM engine (very experimental)" ${DEFAULT_ON})
OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT_ON})
OPTION(ENABLE_LIQMIGRATION "Enable liquid control (very experimental), see [Mani2013] for details" ${DEFAULT_OFF})
OPTION(ENABLE_LOGGER "Use boost::log library for logging (ON by default)" ${DEFAULT_ON})
OPTION(ENABLE_LS_DEM "Enable level-set shape description" ${DEFAULT_ON})
OPTION(ENABLE_MASK_ARBITRARY "Enable arbitrary precision of bitmask variables (only Body::groupMask yet implemented) (experimental). Use -DMASK_ARBITRARY_SIZE=int to set number of used bits (256 by default)" ${DEFAULT_OFF})
OPTION(ENABLE_MPFR "Use mpfr library (higher precision calculations or CGAL exact predicates)" ${DEFAULT_OFF})
OPTION(ENABLE_MPI "Enable MPI environement and communications, required for coupling Yade with OpenFOAM  " ${DEFAULT_ON})
OPTION(ENABLE_OAR "Generate script for oar-based task scheduler" ${DEFAULT_OFF})
OPTION(ENABLE_OPENMP "Enable OpenMP" ${DEFAULT_ON})
OPTION(ENABLE_PARTIALSAT "Enable the partially saturated clay engine" ${DEFAULT_ON})
OPTION(ENABLE_PFVFLOW "Enable one-phase flow engines" ${DEFAULT_ON})
OPTION(ENABLE_POTENTIAL_BLOCKS "Enable PotentialBlocks" ${DEFAULT_ON})
OPTION(ENABLE_POTENTIAL_PARTICLES "Enable potential particles" ${DEFAULT_ON})
OPTION(ENABLE_PROFILING "Enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)" ${DEFAULT_OFF})
OPTION(ENABLE_REAL_HP "allow using twice, quadruple or higher precisions of Real" ${DEFAULT_ON})
OPTION(ENABLE_SPH "Enable SPH" ${DEFAULT_OFF})
OPTION(ENABLE_THERMAL "Enable thermal engine (experimental)" ${DEFAULT_ON})
OPTION(ENABLE_TWOPHASEFLOW "Enable two-phase flow engines" ${DEFAULT_ON})
OPTION(ENABLE_USEFUL_ERRORS "enable useful compiler errors which help a lot in error-free development." ${DEFAULT_ON})
OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT_ON})
OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver" ${DEFAULT_OFF})
OPTION(USE_QT5 "USE Qt5 for GUI" ${DEFAULT_ON})
#Set -DPYTHON_VERSION numeric option below:
set(PYTHON_VERSION -1 CACHE STRING "Force python version to the given one. Defaults to -DPYTHON_VERSION=-1 which automatically uses the newest available python version on the system.")
#===========================================================



set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

INCLUDE(GetVersion)
INCLUDE(GNUInstallDirs)

INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})

#===========================================================
# HACK!!! If the version of gcc is 4.8 or greater, we add -ftrack-macro-expansion=0
# and -save-temps into compiler to reduce the memory consumption during compilation.
# See http://bugs.debian.org/726009 for more information
# Can be removed later, if gcc fixes its regression
# Taken from http://stackoverflow.com/questions/4058565/check-gcc-minor-in-cmake

# this line was trying to get the g++ version. But it does not work with ccache.
# But we already have CMAKE_CXX_COMPILER_VERSION, so we don't need this line!
#EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")  # Check whether we compile with GCC
  IF (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.8)
    MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0")
    ADD_DEFINITIONS("-ftrack-macro-expansion=0")
  ELSE()
    MESSAGE(STATUS "GCC Version < 4.8. will not use -ftrack-macro-expansion=0")
  ENDIF()
ENDIF()

# -save-temps is not supported with ccache
IF ((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8 OR CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL 4.8) AND ( NOT "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" AND NOT "${CMAKE_CXX_COMPILER}" MATCHES ".*ccache.*" AND NOT DISABLE_SAVE_TEMPS))
  MESSAGE(STATUS "GCC Version >= 4.8. Adding -save-temps")
  ADD_DEFINITIONS("-save-temps")
ELSE()
  IF ( "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" OR "${CMAKE_CXX_COMPILER}" MATCHES ".*ccache.*" )
    MESSAGE(STATUS "ccache detected, will not use -save-temps")
# on ubuntu 18.04 and 18.10 when ccache is used we need to fix some bug, see https://gitlab.kitware.com/cmake/cmake/issues/17275
# but we can't do this on ubuntu 16.04 with cmake version 3.5.1, because that produces error: "list does not recognize sub-command FILTER".
# So we must be above version 3.6, because https://cmake.org/cmake/help/v3.6/release/3.6.html?highlight=filter
# Later maybe on some higher cmake version this will become unnecessary.
    IF(CMAKE_VERSION VERSION_GREATER 3.6 OR CMAKE_VERSION VERSION_EQUAL 3.6)
        string (STRIP "${CMAKE_CXX_COMPILER_ARG1}" __CXX_COMPILER_ARG1)
        set(CMAKE_CXX_COMPILER_PREDEFINES_COMMAND "${CMAKE_CXX_COMPILER}" "${__CXX_COMPILER_ARG1}" "-dM" "-E" "-c" "${CMAKE_ROOT}/Modules/CMakeCXXCompilerABI.cpp")
        list(FILTER CMAKE_CXX_COMPILER_PREDEFINES_COMMAND EXCLUDE REGEX "^$")
        unset(__CXX_COMPILER_ARG1)
    ENDIF()
  ELSE()

=== py/CMakeLists.txt ===
#==================pygts=========================================
IF(ENABLE_GTS)
  find_python_module(gts)
  IF (PY_gts)
    MESSAGE(STATUS "Use system gts version")
  ELSE (PY_gts)
    MESSAGE(STATUS "Use embedded version of gts. Please, consider installing the corresponding package")
    FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.cpp")
    ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
    SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
    SET_TARGET_PROPERTIES(_gts PROPERTIES  UNITY_BUILD OFF) # a bunch of multiple declarations there
    TARGET_LINK_LIBRARIES(_gts gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
  ENDIF (PY_gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

#==================pyModules=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.4/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
FILE(GLOB filesFEMxDEM "${CMAKE_CURRENT_SOURCE_DIR}/FEMxDEM/*.py")
INSTALL(FILES ${filesFEMxDEM} DESTINATION ${YADE_PY_PATH}/yade/FEMxDEM)

ADD_LIBRARY(_libVersions SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_libVersions.cpp")
SET_TARGET_PROPERTIES(_libVersions PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_libVersions ${VTK_LIBRARIES})
TARGET_INCLUDE_DIRECTORIES(_libVersions PUBLIC ${Qt5Widgets_INCLUDE_DIRS} ${Qt5OpenGL_INCLUDE_DIRS})
INSTALL(TARGETS _libVersions DESTINATION "${YADE_PY_PATH}/yade/")

# hint: follow changes in d067b0696a8 to add new modules.
ADD_LIBRARY(_log SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_log.cpp")
SET_TARGET_PROPERTIES(_log PROPERTIES PREFIX "")
INSTALL(TARGETS _log DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_math SHARED "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_math.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeStorageOrdering.cpp")
SET_TARGET_PROPERTIES(_math PROPERTIES PREFIX "")
INSTALL(TARGETS _math DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_minieigenHP SHARED "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_minieigenHP.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeBoxes.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeComplex1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeComplex2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeConverters.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeMatrices1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeMatrices2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeQuaternion.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeStorageOrdering.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeVectors1.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_ExposeVectors2.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/high-precision/_RealHPDiagnostics.cpp")
SET_TARGET_PROPERTIES(_minieigenHP PROPERTIES PREFIX "")
INSTALL(TARGETS _minieigenHP DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_polyhedra_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_polyhedra_utils.cpp")
SET_TARGET_PROPERTIES(_polyhedra_utils PROPERTIES PREFIX "")
INSTALL(TARGETS _polyhedra_utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
IF(ENABLE_GTS AND NOT(PY_gts))
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS AND NOT(PY_gts))


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

IF(ENABLE_LOGGER AND CMAKE_UNITY_BUILD)
	MESSAGE(STATUS "${Esc}[93mENABLE_LOGGER needs a workaround with CMAKE_UNITY_BUILD, adding .cpp files containing CREATE_CPP_LOCAL_LOGGER to SKIP_UNITY_BUILD_INCLUSION.${Esc}[0m")
	SET(FIND_CPP_LOGGER_ARGS -rZl CREATE_CPP_LOCAL_LOGGER ${CMAKE_SOURCE_DIR}/py --include=*.cpp)
	EXECUTE_PROCESS( COMMAND grep ${FIND_CPP_LOGGER_ARGS} COMMAND sed -e "s/\\x0/;/g" OUTPUT_VARIABLE FILES_WITH_CPP_LOGGER OUTPUT_STRIP_TRAILING_WHITESPACE)
	FOREACH(CPP_LOGGER_USED_HERE ${FILES_WITH_CPP_LOGGER})
		MESSAGE(STATUS "Adding ${CPP_LOGGER_USED_HERE} to SKIP_UNITY_BUILD_INCLUSION")
		SET_PROPERTY(SOURCE ${CPP_LOGGER_USED_HERE} PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
	ENDFOREACH(CPP_LOGGER_USED_HERE)
ENDIF(ENABLE_LOGGER AND CMAKE_UNITY_BUILD)

=== debian/changelog ===
yade (2022.01a-7) unstable; urgency=medium

  * [60318e0] Fix compilation against python3.10
  * [6b8771d] Fix typo in d/rules
  * [50f426a] Apply cme fix dpkg
  * [f335d77] Re-export upstream signing key without extra signatures.

 -- Anton Gladky <gladk@debian.org>  Mon, 21 Mar 2022 21:59:26 +0100

yade (2022.01a-6) unstable; urgency=medium

  * [064dad3] Disable polyhedra-check (random failure)
  * [6810277] Disable longdouble on ppc64el due to crash

 -- Anton Gladky <gladk@debian.org>  Sun, 30 Jan 2022 22:24:02 +0100

yade (2022.01a-5) unstable; urgency=medium

  * [18456f2] Minor update in d/rules
  * Upload into unstable

 -- Anton Gladky <gladk@debian.org>  Fri, 28 Jan 2022 21:45:41 +0100

yade (2022.01a-5~exp3) experimental; urgency=medium

  * [bc47573] Remove executive flag from debian/yade.links

 -- Anton Gladky <gladk@debian.org>  Thu, 27 Jan 2022 21:53:36 +0100

yade (2022.01a-5~exp2) experimental; urgency=medium

  * [9908b97] Import patch from upstream, hp-precision
  * [b9eb6e2] Disable debug-info
  * [45d907b] Build float128 only on i386 and amd64
  * [69d4d14] Link yade-double onto yade

 -- Anton Gladky <gladk@debian.org>  Wed, 26 Jan 2022 23:00:42 +0100

yade (2022.01a-5~exp1) experimental; urgency=medium

  * [903cd50] Build real-hp binaries

 -- Anton Gladky <gladk@debian.org>  Mon, 24 Jan 2022 21:08:02 +0100

yade (2022.01a-4) unstable; urgency=medium

  * [5ce4c3f] Enable HP-builds

 -- Anton Gladky <gladk@debian.org>  Wed, 19 Jan 2022 21:48:19 +0100

yade (2022.01a-3) unstable; urgency=medium

  * [cc2eda2] Disable REAL_HP on i386 and ppc64el

 -- Anton Gladky <gladk@debian.org>  Mon, 17 Jan 2022 07:08:04 +0100

yade (2022.01a-2) unstable; urgency=medium

  * [0b10d04] Disable REAL_HP on arm64 and s390x due to build failures
  * [02633b2] Add debian/upstream/signing-key.asc

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Jan 2022 20:54:00 +0100

yade (2022.01a-1) unstable; urgency=medium

  * [1d00544] New upstream version 2022.01a
  * [69672ae] Refresh patches

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Jan 2022 18:11:14 +0100

yade (2021.11~git~6f71ebd-1) unstable; urgency=medium

  * [8b5ce9c] Update d/watch
  * [d9a65d5] New upstream version 2021.11~git~6f71ebd. (Closes: #984421)
  * [2ff5d77] Clean d/patches
  * [36d8e29] Use no-as-needed in d/rules
  * [8ae7d89] Set Standards-Version: 4.6.0

 -- Anton Gladky <gladk@debian.org>  Tue, 09 Nov 2021 22:01:35 +0100

=== debian/control ===
Source: yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-exec,
               dh-python,
               freeglut3-dev,
               help2man,
               libboost-all-dev,
               libbz2-dev,
               libcgal-dev,
               libeigen3-dev,
               libgl1-mesa-dev,
               libgmp-dev,
               libgts-dev,
               libmetis-dev,
               libmpc-dev,
               libmpfr-dev,
               libmpfrc++-dev,
               libopenblas-dev,
               libqglviewer-dev-qt5,
               libsqlite3-dev,
               libsuitesparse-dev,
               libvtk9-dev,
               libxi-dev,
               libxmu-dev,
               pyqt5-dev-tools,
               python3-dev,
               python3-future,
               python3-ipython,
               python3-matplotlib,
               python3-minieigen,
               python3-mpi4py,
               python3-mpmath,
               python3-numpy,
               python3-pil,
               python3-pygraphviz,
               python3-pyqt5,
               python3-pyqt5.qtsvg,
               python3-tk,
               python3-xlib,
               zlib1g-dev
Build-Depends-Indep: dvipng,
                     graphviz,
                     libjs-jquery,
                     lmodern,
                     python3-bibtexparser,
                     python3-sphinx,
                     texlive-fonts-recommended,
                     texlive-plain-generic,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-pictures,
                     texlive-xetex,
                     tipa
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/yade
Vcs-Git: https://salsa.debian.org/science-team/yade.git
Homepage: https://yade-dem.org/doc/

Package: yade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: foreign
Depends: gnuplot,
         libyade (= ${binary:Version}),
         python3-yade (= ${binary:Version}),
         python3-ipython,
         python3-mpi4py,
         python3-pyqt5.qtwebkit,
         ${python3:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: libyade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Libraries
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains yade`s libraries.

Package: python3-yade
Architecture: amd64 arm64 i386 ppc64el s390x
Multi-Arch: foreign
Section: python
Depends: libyade (= ${binary:Version}),
         python3-future,
         python3-matplotlib,
         python3-mpmath,
         python3-pil,
         python3-pyqt5,
         python3-pyqt5.qtsvg,
         python3-tk,
         python3-xlib,
         python3-mpi4py,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Python bindings
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains python bindings for yade.

Package: yade-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends},
         libjs-mathjax
Recommends: yade
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DOUBLE_SUFFIX=double
LONGDOUBLE_SUFFIX=longdouble
FLOAT128_SUFFIX=float128
MPFR150_SUFFIX=mpfr150

BUILDDIR = $(CURDIR)/debian/build
tmpInstall = $(CURDIR)/debian/tmp
tmpDirMatplotLib = $(CURDIR)/debian/matplotlib

# do not build i386 parallely
ifneq (,$(filter $(DEB_HOST_ARCH), i386 s390x all))
  parallelBuild=--no-parallel
endif

# We disable parallel builds on all platforms by now
# Ubuntu has problems with it and it causes sync-delays
parallelBuild=--no-parallel

%:
	dh $@ --builddirectory=$(BUILDDIR) --with python3 $(parallelBuild)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed,-no-keep-memory

# no debug info to avoid running
# out of address space when linking
export DEB_CXXFLAGS_MAINT_APPEND += -g0

# Check, whether Build-Depends-Indep are installed
BUILD_DOC=$(shell dpkg -s python3-sphinx | grep -q "^Status:.* installed$$" && echo yes)

LD_LIBRARY_PATH_DOUBLE =  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX):$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX)/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX)/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(DOUBLE_SUFFIX)/py/yade/qt:$(LD_LIBRARY_PATH)
LD_LIBRARY_PATH_LONGDOUBLE =  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX):$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX)/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX)/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(LONGDOUBLE_SUFFIX)/py/yade/qt:$(LD_LIBRARY_PATH)
LD_LIBRARY_PATH_FLOAT128 =  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX):$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX)/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX)/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(FLOAT128_SUFFIX)/py/yade/qt:$(LD_LIBRARY_PATH)
LD_LIBRARY_PATH_MPFR150 =  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX):$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX)/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX)/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX)/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade-$(MPFR150_SUFFIX)/py/yade/qt:$(LD_LIBRARY_PATH)

export MPLCONFIGDIR := $(tmpDirMatplotLib)
export HOME := $(tmpDirMatplotLib)
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export YADE_PREFIX := $(tmpInstall)/usr

extra_flags += \
-DruntimePREFIX="/usr" \
-DCMAKE_INSTALL_PREFIX="/usr" \
-DLIBRARY_OUTPUT_PATH=lib/$(DEB_HOST_MULTIARCH) \
-DENABLE_SPH=OFF \
-DENABLE_MPFR=ON \
-DPYTHON_VERSION=3

# Do not use real_hp on arm64 and s390z.
# It fails because quadmath.h cannot be found. Can be checked with a newer boost (>1.74)

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags) -B$(BUILDDIR)-$(DOUBLE_SUFFIX) -DSUFFIX=-$(DOUBLE_SUFFIX) -DREAL_DECIMAL_PLACES=15
ifeq (,$(filter $(DEB_HOST_ARCH), ppc64el)) # Disable longdouble on ppc64el due to crash
	dh_auto_configure -- $(extra_flags) -B$(BUILDDIR)-$(LONGDOUBLE_SUFFIX) -DSUFFIX=-$(LONGDOUBLE_SUFFIX) -DREAL_DECIMAL_PLACES=18
endif
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
	dh_auto_configure -- $(extra_flags) -B$(BUILDDIR)-$(FLOAT128_SUFFIX) -DSUFFIX=-$(FLOAT128_SUFFIX) -DREAL_DECIMAL_PLACES=33
endif
	dh_auto_configure -- $(extra_flags) -B$(BUILDDIR)-$(MPFR150_SUFFIX) -DSUFFIX=-$(MPFR150_SUFFIX) -DREAL_DECIMAL_PLACES=150
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo

override_dh_auto_build:
	dh_auto_build -B$(BUILDDIR)-$(DOUBLE_SUFFIX)
ifeq (,$(filter $(DEB_HOST_ARCH), ppc64el))
	dh_auto_build -B$(BUILDDIR)-$(LONGDOUBLE_SUFFIX)
endif
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
	dh_auto_build -B$(BUILDDIR)-$(FLOAT128_SUFFIX)
endif
	dh_auto_build -B$(BUILDDIR)-$(MPFR150_SUFFIX)

override_dh_auto_install:
	dh_auto_install -B$(BUILDDIR)-$(DOUBLE_SUFFIX)
ifeq (,$(filter $(DEB_HOST_ARCH), ppc64el))
	dh_auto_install -B$(BUILDDIR)-$(LONGDOUBLE_SUFFIX)
endif
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
	dh_auto_install -B$(BUILDDIR)-$(FLOAT128_SUFFIX)
endif
	dh_auto_install -B$(BUILDDIR)-$(MPFR150_SUFFIX)
	# generate manpages
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) help2man $(tmpInstall)/usr/bin/yade-double > yade.1
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) help2man $(tmpInstall)/usr/bin/yade-double-batch > yade-batch.1
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) $(tmpInstall)/usr/bin/yade-$(DOUBLE_SUFFIX) --test
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) $(tmpInstall)/usr/bin/yade-$(DOUBLE_SUFFIX) --check
ifeq (,$(filter $(DEB_HOST_ARCH), ppc64el))
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_LONGDOUBLE) $(tmpInstall)/usr/bin/yade-$(LONGDOUBLE_SUFFIX) --test
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_LONGDOUBLE) $(tmpInstall)/usr/bin/yade-$(LONGDOUBLE_SUFFIX) --check
endif
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_FLOAT128) $(tmpInstall)/usr/bin/yade-$(FLOAT128_SUFFIX) --test
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_FLOAT128) $(tmpInstall)/usr/bin/yade-$(FLOAT128_SUFFIX) --check
endif
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_MPFR150) $(tmpInstall)/usr/bin/yade-$(MPFR150_SUFFIX) --test
	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_MPFR150) $(tmpInstall)/usr/bin/yade-$(MPFR150_SUFFIX) --check
	dh_numpy3
ifeq ($(BUILD_DOC), yes)
	#Generate docs
	cd $(CURDIR)/doc/sphinx && LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) PYTHONPATH=. $(tmpInstall)/usr/bin/yade-$(DOUBLE_SUFFIX) yadeSphinx.py html && LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_DOUBLE) PYTHONPATH=. $(tmpInstall)/usr/bin/yade-$(DOUBLE_SUFFIX) yadeSphinx.py latex && cd _build/latex && xelatex Yade.tex && xelatex Yade.tex && xelatex Yade.tex
	cd $(CURDIR)/doc/sphinx/_build/html && find . -type f -print0 | xargs -0 sed -i 's/https:\/\/cdnjs\.cloudflare\.com\/ajax\/libs\/mathjax\/2\.7\.5\/latest.js/\/usr\/share\/javascript\/mathjax\/MathJax.js\//g'
	cd $(CURDIR)/doc/sphinx/_build/html && find . -type f -print0 | xargs -0 sed -i 's/https:\/\/www\.youtube\.com//g'
endif
	#Delete all pyc files
	find $(tmpInstall) -name '*.pyc' -print0 | xargs -0 rm -f
	find $(tmpInstall) -name '__pycache__' -print0 | xargs -0 rm -rf
	find $(tmpInstall) -name 'yade.py' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_test:

ifeq ($(BUILD_DOC), yes)
execute_after_dh_installdocs:
	dh_sphinxdoc
endif

execute_after_dh_auto_clean:
	rm -rf $(BUILDDIR)-$(DOUBLE_SUFFIX)
	rm -rf $(BUILDDIR)-$(LONGDOUBLE_SUFFIX)
	rm -rf $(BUILDDIR)-$(FLOAT128_SUFFIX)
	rm -rf $(BUILDDIR)-$(MPFR150_SUFFIX)
	rm -rf $(CURDIR)/yade.1
	rm -rf $(CURDIR)/yade-batch.1
	rm -rf $(tmpDirMatplotLib)
	rm -rf $(CURDIR)/doc/sphinx/_build
	rm -rf $(CURDIR)/doc/sphinx/__pycache__

## yade 2023.02a

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,9 @@
 #  ENABLE_POTENTIAL_BLOCKS    : enable potential blocks option (ON by default)
 #  ENABLE_POTENTIAL_PARTICLES : enable potential particles option (ON by default)
 #  ENABLE_PROFILING           : enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)
-#  ENABLE_REAL_HP             : allow using twice, quadruple or higher precisions of Real
+#  ENABLE_REAL_HP             : allow using twice, quadruple or higher precisions of Real. It is not advertised in yade.config.features because of frequent confusion
+#                               with output of yade.math.usesHP() as described in https://gitlab.com/yade-dev/trunk/-/issues/247
+#                               Please call yade.math.getRealHPCppDigits10() and yade.math.getRealHPPythonDigits10() instead.
 #  ENABLE_SPH                 : enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default)
 #  ENABLE_THERMAL             : enable thermal engine (ON by default, experimental)"
 #  ENABLE_TWOPHASEFLOW        : enable TWOPHASEFLOW-option, TwoPhaseFlowEngine (ON by default)
@@ -49,6 +51,7 @@
 #  CHOLMOD_GPU link Yade to custom SuiteSparse installation and activate GPU accelerated PFV (OFF by default)
 #  SUITESPARSEPATH: define this variable with the path to a custom suitesparse install
 #  PYTHON_VERSION: force python version to the given one, set -1 to automatically use the last version on the system. (-1 by default)
+#  DISABLE_PKGS : comma-separated list of disabled packages from 'pkg', 'preprocessing' or 'postprocessing', if empty all packages will be built.The packages `common` and `dem` are required to run, but the project can be compiled without them. (EMPTY by default)
 
 project(Yade C CXX)
 cmake_minimum_required(VERSION 3.5.0)
@@ -120,9 +123,12 @@
 OPTION(ENABLE_USEFUL_ERRORS "enable useful compiler errors which help a lot in error-free development." ${DEFAULT_ON})
 OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT_ON})
 OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver" ${DEFAULT_OFF})
-OPTION(USE_QT5 "USE Qt5 for GUI" ${DEFAULT_ON})
+OPTION(USE_QT5 "USE Qt5 for GUI" ON)
+
 #Set -DPYTHON_VERSION numeric option below:
 set(PYTHON_VERSION -1 CACHE STRING "Force python version to the given one. Defaults to -DPYTHON_VERSION=-1 which automatically uses the newest available python version on the system.")
+
+set(DISABLE_PKGS "" CACHE STRING "Comma-separated list of disabled packages from 'pkg', 'preprocessing' or 'postprocessing', if empty all packages will be built.")
 #===========================================================
 
 
@@ -162,13 +168,3 @@
   IF ( "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" OR "${CMAKE_CXX_COMPILER}" MATCHES ".*ccache.*" )
     MESSAGE(STATUS "ccache detected, will not use -save-temps")
 # on ubuntu 18.04 and 18.10 when ccache is used we need to fix some bug, see https://gitlab.kitware.com/cmake/cmake/issues/17275
-# but we can't do this on ubuntu 16.04 with cmake version 3.5.1, because that produces error: "list does not recognize sub-command FILTER".
-# So we must be above version 3.6, because https://cmake.org/cmake/help/v3.6/release/3.6.html?highlight=filter
-# Later maybe on some higher cmake version this will become unnecessary.
-    IF(CMAKE_VERSION VERSION_GREATER 3.6 OR CMAKE_VERSION VERSION_EQUAL 3.6)
-        string (STRIP "${CMAKE_CXX_COMPILER_ARG1}" __CXX_COMPILER_ARG1)
-        set(CMAKE_CXX_COMPILER_PREDEFINES_COMMAND "${CMAKE_CXX_COMPILER}" "${__CXX_COMPILER_ARG1}" "-dM" "-E" "-c" "${CMAKE_ROOT}/Modules/CMakeCXXCompilerABI.cpp")
-        list(FILTER CMAKE_CXX_COMPILER_PREDEFINES_COMMAND EXCLUDE REGEX "^$")
-        unset(__CXX_COMPILER_ARG1)
-    ENDIF()
-  ELSE()

=== gui/CMakeLists.txt ===
IF(${ENABLE_GUI})
  INCLUDE_DIRECTORIES(${QGLVIEWER_INCLUDE_DIR})
  IF(USE_QT5)
    SET(CMAKE_AUTOMOC ON)
    SET(_GLViewer_SOURCE_FILES qt5/GLViewer.cpp;qt5/_GLViewer.cpp;qt5/OpenGLManager.cpp;qt5/GLViewerDisplay.cpp;qt5/GLViewerMouse.cpp)
    ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES})
    SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${FREEGLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5" "--from-imports" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${FREEGLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5"  "--from-imports" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  ELSE(USE_QT5)
    MESSAGE(FATAL_ERROR "QT4 is no longer supported")
  ENDIF(USE_QT5)
  SET_PROPERTY(SOURCE ${CMAKE_SOURCE_DIR}/gui/qt5/_GLViewer.cpp PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
ENDIF(${ENABLE_GUI})

=== py/CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,8 @@
 INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
 FILE(GLOB filesFEMxDEM "${CMAKE_CURRENT_SOURCE_DIR}/FEMxDEM/*.py")
 INSTALL(FILES ${filesFEMxDEM} DESTINATION ${YADE_PY_PATH}/yade/FEMxDEM)
+FILE(GLOB bf "${CMAKE_CURRENT_SOURCE_DIR}/bf/*.py")
+INSTALL(FILES ${bf} DESTINATION ${YADE_PY_PATH}/yade/bf)
 
 ADD_LIBRARY(_libVersions SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_libVersions.cpp")
 SET_TARGET_PROPERTIES(_libVersions PROPERTIES PREFIX "")
@@ -88,6 +90,11 @@
 SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
 INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")
 
+FILE(GLOB_RECURSE YMPORT_CPP_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/ymport/*.cpp)
+ADD_LIBRARY(_ymport SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_ymport.cpp" ${YMPORT_CPP_SRCS})
+SET_TARGET_PROPERTIES(_ymport PROPERTIES PREFIX "")
+INSTALL(TARGETS _ymport DESTINATION "${YADE_PY_PATH}/yade/")
+
 IF(ENABLE_LOGGER AND CMAKE_UNITY_BUILD)
 	MESSAGE(STATUS "${Esc}[93mENABLE_LOGGER needs a workaround with CMAKE_UNITY_BUILD, adding .cpp files containing CREATE_CPP_LOCAL_LOGGER to SKIP_UNITY_BUILD_INCLUSION.${Esc}[0m")
 	SET(FIND_CPP_LOGGER_ARGS -rZl CREATE_CPP_LOCAL_LOGGER ${CMAKE_SOURCE_DIR}/py --include=*.cpp)

=== scripts/ppa_ci/aptly/Makefile ===
build:
	docker build -t aptly:yade -f Dockerfile .

=== debian/changelog ===
yade (2023.02a-1) unstable; urgency=medium

  * Upload into unstable.

 -- Anton Gladky <gladk@debian.org>  Sun, 05 Feb 2023 09:18:14 +0100

yade (2023.02a-1~exp4) experimental; urgency=medium

  * [3a4e777] Add python3-ipython-genutils into BD.

 -- Anton Gladky <gladk@debian.org>  Sat, 04 Feb 2023 09:36:16 +0100

yade (2023.02a-1~exp3) experimental; urgency=medium

  * [47c6bba] Disable checkCapillaryEngineStandalone test.

 -- Anton Gladky <gladk@debian.org>  Fri, 03 Feb 2023 19:33:33 +0100

yade (2023.02a-1~exp2) experimental; urgency=medium

  * [b900b80] Add python3.11 as supported.

 -- Anton Gladky <gladk@debian.org>  Thu, 02 Feb 2023 21:34:00 +0100

yade (2023.02a-1~exp1) experimental; urgency=medium

  * [dcff066] New upstream version 2023.02a. (Closes: #1028983, #1022735)
  * [873e430] Remove all patches (applied by upstream)
  * [ad4babe] Remove lintian overrides

 -- Anton Gladky <gladk@debian.org>  Thu, 02 Feb 2023 07:23:39 +0100

yade (2022.01a-13) unstable; urgency=medium

  * [03b172a] Fix doc: import error in make doc. (Closes: #1022735)
  * [8e92f56] Set upstream metadata fields: Bug-Database, Bug-Submit.
  * [f97e430] Update standards version to 4.6.2, no changes needed.

 -- Anton Gladky <gladk@debian.org>  Sat, 14 Jan 2023 21:29:32 +0100

yade (2022.01a-12) unstable; urgency=medium

  * [b29c74b] Drop mpfr150 test on i386

 -- Anton Gladky <gladk@debian.org>  Thu, 01 Sep 2022 19:11:57 +0200

yade (2022.01a-11) unstable; urgency=medium

  * [c1ead14] Fix i386 and ppc64el builds.

 -- Anton Gladky <gladk@debian.org>  Sun, 28 Aug 2022 12:45:34 +0200

yade (2022.01a-10) unstable; urgency=medium

  * [5528878] Fix GCC-12 FTBFS. (Closes: #1013072)
  * [884074b] Fix tests. (Closes: #1013932)
  * [2641285] Set Standards-Version: 4.6.1

 -- Anton Gladky <gladk@debian.org>  Sun, 21 Aug 2022 12:23:09 +0200

yade (2022.01a-9) unstable; urgency=medium

  * [cd0712a] Revert "Do not run a special test on i386."
              Potential bug is fixed in the boost1.74.

 -- Anton Gladky <gladk@debian.org>  Thu, 02 Jun 2022 22:43:59 +0200

yade (2022.01a-8) unstable; urgency=medium

  * [fc5ece6] Do not run a special test on i386. (Closes: #1009739)

 -- Anton Gladky <gladk@debian.org>  Thu, 26 May 2022 17:39:05 +0200

=== debian/control ===
--- 
+++ 
@@ -45,6 +45,7 @@
                zlib1g-dev
 Build-Depends-Indep: dvipng,
                      graphviz,
+                     python3-ipython-genutils,
                      libjs-jquery,
                      lmodern,
                      python3-bibtexparser,
@@ -56,7 +57,7 @@
                      texlive-pictures,
                      texlive-xetex,
                      tipa
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/yade
 Vcs-Git: https://salsa.debian.org/science-team/yade.git
 Homepage: https://yade-dem.org/doc/

=== debian/rules ===
--- 
+++ 
@@ -100,8 +100,10 @@
 	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_FLOAT128) $(tmpInstall)/usr/bin/yade-$(FLOAT128_SUFFIX) --test
 	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_FLOAT128) $(tmpInstall)/usr/bin/yade-$(FLOAT128_SUFFIX) --check
 endif
+ifeq (,$(filter $(DEB_HOST_ARCH), i386))
 	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_MPFR150) $(tmpInstall)/usr/bin/yade-$(MPFR150_SUFFIX) --test
 	LD_LIBRARY_PATH=$(LD_LIBRARY_PATH_MPFR150) $(tmpInstall)/usr/bin/yade-$(MPFR150_SUFFIX) --check
+endif
 	dh_numpy3
 ifeq ($(BUILD_DOC), yes)
 	#Generate docs
